---
title: PostgreSQL JDBC Driver 42.2.5 Released
date: 2018-08-27 18:21:38 +0300
categories:
  - new_release
version: 42.2.5
---
**Notable changes**

### Known issues
- 1ms per async copy call [issue 1312](https://github.com/pgjdbc/pgjdbc/issues/1312)

### Changed
- `ssl=true` implies `sslmode=verify-full`, that is it requires valid server certificate [cdeeaca4](https://github.com/pgjdbc/pgjdbc/commit/cdeeaca47dc3bc6f727c79a582c9e4123099526e)

### Added
- Support for `sslmode=allow/prefer/require` [cdeeaca4](https://github.com/pgjdbc/pgjdbc/commit/cdeeaca47dc3bc6f727c79a582c9e4123099526e)

### Fixed
- Security: added server hostname verification for non-default SSL factories in `sslmode=verify-full` (CVE-2018-10936) [cdeeaca4](https://github.com/pgjdbc/pgjdbc/commit/cdeeaca47dc3bc6f727c79a582c9e4123099526e)
- Updated documentation on SSL configuration [fa032732](https://github.com/pgjdbc/pgjdbc/commit/fa032732acfe51c6e663ee646dd5c1beaa1af857)
- Updated Japanese translations [PR 1275](https://github.com/pgjdbc/pgjdbc/pull/1275)
- IndexOutOfBounds on prepared multistatement with insert values [c2885dd0](https://github.com/pgjdbc/pgjdbc/commit/c2885dd0cfc793f81e5dd3ed2300bb32476eb14a)


<!--more-->

**Commits by author**

Christoph Berg (1):

* chore: remove editor backup files [PR 1255](https://github.com/pgjdbc/pgjdbc/pull/1255) [b1b1afb8](https://github.com/pgjdbc/pgjdbc/commit/b1b1afb829fae06bcefce443e66d823f4f92fed5)

Dave Cramer (4):

* Update Contributing.md [1f8ac406](https://github.com/pgjdbc/pgjdbc/commit/1f8ac4063b1fd04ccc05616e3533d68be9912333)
* Add issue templates [PR 1263](https://github.com/pgjdbc/pgjdbc/pull/1263) [c66bf710](https://github.com/pgjdbc/pgjdbc/commit/c66bf7108dd36f50aacebfd4f09e383aed02424b)
* move issue template and pull request template into github specific di… [PR 1283](https://github.com/pgjdbc/pgjdbc/pull/1283) [b5c19af6](https://github.com/pgjdbc/pgjdbc/commit/b5c19af627c8650410495ad8e3f2ee85e687e3c1)
* docs: improve documentation on SSL [fa032732](https://github.com/pgjdbc/pgjdbc/commit/fa032732acfe51c6e663ee646dd5c1beaa1af857)

Kazuhiro Sera (1):

* docs: fix typos detected by github.com/client9/misspell [PR 1287](https://github.com/pgjdbc/pgjdbc/pull/1287) [9534e9ca](https://github.com/pgjdbc/pgjdbc/commit/9534e9ca0e1840445ad5f4eee75bc1e2ac102dde)

Kyotaro Horiguchi (1):

* fix: Japanese translation [PR 1275](https://github.com/pgjdbc/pgjdbc/pull/1275) [993a3beb](https://github.com/pgjdbc/pgjdbc/commit/993a3beba10aed73418340b14f2d3420c8984de5)

Sehrope Sarkuni (1):

* fix: Correct typo in CopyManager comment [PR 1285](https://github.com/pgjdbc/pgjdbc/pull/1285) [203a106d](https://github.com/pgjdbc/pgjdbc/commit/203a106ddc9eb0d94cc94838f4fb0924e37f441a)

Vladimir Sitnikov (12):

* reflect 42.2.4 release in readme.md [b99cea0d](https://github.com/pgjdbc/pgjdbc/commit/b99cea0de0e67f0c641c77bcbff8d2889a441290)
* doc: add SQL_TSI to the known issues for 42.2.3 [ci-skip] [2da319a0](https://github.com/pgjdbc/pgjdbc/commit/2da319a07d47015467bd3ace029827f67f4778bc)
* docs: escape underscores in changelog otherwise it produces italic [b1507f84](https://github.com/pgjdbc/pgjdbc/commit/b1507f849b732012d5312c79a62dad24fd6a7261)
* docs: typo in 42.2.3 changelog "minute->second" [5898cdf1](https://github.com/pgjdbc/pgjdbc/commit/5898cdf1e314f2db7889456fb1ad6822021bd543)
* refactor: remove unused PgPreparedStatement.adjustIndex [PR 1253](https://github.com/pgjdbc/pgjdbc/pull/1253) [178eecc9](https://github.com/pgjdbc/pgjdbc/commit/178eecc90643b36c8c5cd423ff311b26733384f2)
* test: run testShortQueryTimeout in PG_VERSION=HEAD Travis job only [PR 1270](https://github.com/pgjdbc/pgjdbc/pull/1270) [ecd412e4](https://github.com/pgjdbc/pgjdbc/commit/ecd412e4164bbfcccd96f778c874dd4f40330354)
* fix: remove POT-Creation-Date from generated .po and .pot files [PR 1269](https://github.com/pgjdbc/pgjdbc/pull/1269) [450a496b](https://github.com/pgjdbc/pgjdbc/commit/450a496be8b14e14fa0821413ed532c49275dc9e)
* fix: use UTF-8 encoding in generated translation/messages_*.java files [2cbe7b35](https://github.com/pgjdbc/pgjdbc/commit/2cbe7b354543e2ae526c3d9a422949acd0a375b6)
* fix: typo in "One ore more ClientInfo failed" error message [ci skip] [21e126f4](https://github.com/pgjdbc/pgjdbc/commit/21e126f451df667627c1cc3a0acfb3c38be45ffa)
* fix: IndexOutOfBounds on prepared multistatement with insert values [PR 1289](https://github.com/pgjdbc/pgjdbc/pull/1289) [c2885dd0](https://github.com/pgjdbc/pgjdbc/commit/c2885dd0cfc793f81e5dd3ed2300bb32476eb14a)
* security: implement SSL hostname verification for non-default (LibPQFactory) SSL factories (CVE-2018-10936) [cdeeaca4](https://github.com/pgjdbc/pgjdbc/commit/cdeeaca47dc3bc6f727c79a582c9e4123099526e)
* Update changelog for 42.2.5 [237a89bf](https://github.com/pgjdbc/pgjdbc/commit/237a89bf3058a16a3de37b8c92d2a4d850c6c056)

<a name="contributors_{{ page.version }}"></a>
### Contributors to this release

We thank the following people for their contributions to this release.

[Christoph Berg](https://github.com/ChristophBerg)  
[Dave Cramer](davec@postgresintl.com)  
[Kazuhiro Sera](https://github.com/seratch)  
[Kyotaro Horiguchi](https://github.com/horiguti)  
[Sehrope Sarkuni](https://github.com/sehrope)  
[Vladimir Sitnikov](https://github.com/vlsi)  
